# some routes taken from https://github.com/logan-markewich/llama_index_starter_pack
import os
from langchain.embeddings import OpenAIEmbeddings
import chroma_wrapper as chr
from multiprocessing.managers import BaseManager
from flask import Flask, request, jsonify, make_response, render_template
from flask_cors import CORS
from werkzeug.utils import secure_filename

app = Flask(__name__)
CORS(app)

@app.route("/query", methods=["GET"])
def query_index():

    query_text = request.args.get("text", None)
    if query_text is None:
        return "No text found, please include a ?text=blah parameter in the URL", 400
    
    #if docs are chosen to index:    
    #    response = manager.query_select_docs(query_text)._getvalue()
    #else: index all docs:

    
    
    #queries the database, and returns a text response
    response = chr.query_db(query_text)

    # response_json = {
    #     "text": str(response),
    #     "sources": [{"text": str(x.source_text), 
    #                  "similarity": round(x.similarity, 2),
    #                  "doc_id": str(x.doc_id),
    #                  "start": x.node_info['start'],
    #                  "end": x.node_info['end']
    #                 } for x in response.source_nodes]
    # }

    return make_response(jsonify(response)), 200

# @app.route("/uploadFile", methods=["POST"])
# def upload_file():
#     if 'file' not in request.files:
#         return "Please send a POST request with a file", 400
    
#     filepath = None
#     try:
#         uploaded_file = request.files["file"]
#         filename = secure_filename(uploaded_file.filename)
#         if not os.path.exists(chr.all_files):
#             os.makedirs(chr.all_files)
#         filepath = os.path.join(chr.all_files, os.path.basename(filename))
    
#         uploaded_file.save(filepath)

#         #if request.form.get("filename_as_doc_id", None) is not None:
#         #    manager.insert_into_index(filepath, doc_id=filename)
#         #else:
#         #    manager.insert_into_index(filepath)
#         chr.add_to_db(filepath)

#     except Exception as e:
#         # cleanup temp file
#         if filepath is not None and os.path.exists(filepath):
#             os.remove(filepath)
#         print("Error: {}".format(str(e)))
#         return "Error: {}".format(str(e)), 500

#     # cleanup temp file
#     if filepath is not None and os.path.exists(filepath):
#         os.remove(filepath)

#     return "File inserted!", 200

# @app.route("/getDocuments", methods=["GET"])
# def get_documents():
#     document_list = manager.get_documents_list()._getvalue()

#     return make_response(jsonify(document_list)), 200

# this isnt working
# @app.route("/delDocuments")
# def del_documents():
#     # deletes the list of documents

#     manager.destroy_documents_list()
#     return "Done", 200

# this isnt working
# @app.route("/reset")
# def reset():
#     # resets all saved data
#     manager.reset()
#     return "Done", 200

@app.route("/")
def home():
    return render_template('demo.html')

# @app.route("/oldmain")
# def oldmain():
#     return render_template('main.html')

# @app.route("/syntrofos")
# def syntrofos():
#     return render_template('syntrofos.html')

# @app.route("/engrafo")
# def engrafo():
#     return render_template('engrafo.html')

# @app.route("/demo")
# def demo():
#     return render_template('demo.html')

if __name__ == "__main__":
    app.run(host="127.0.0.1", port=8080, debug=False)