// Upload New Files
const form = document.getElementById('uploadForm');

// wait for submission
form.addEventListener('submit', function (e) {
    e.preventDefault();

    // get the current docs to see what is already in the db
    allFiles = [];
    newFile = "";

    // get the file input
    const fileInput = document.getElementById('formFileMultiple');

    // create a new formData constant to store the data we get, use the file name as the id
    const formData = new FormData();
    for (let i = 0; i < fileInput.files.length; i++) {
        newFile = fileInput.files[i].name;
        formData.append('file', fileInput.files[i]);
    }
    formData.append("filename_as_doc_id", "true")

    // only upload the file if it does not already exist
    if (!allFiles.includes(newFile)) {
        // create the XML HTTP request and send it
        const xhr = new XMLHttpRequest();
        xhr.open('POST', '/uploadFile', true);
        xhr.onload = function () {
            // if succesful
            if (xhr.status === 200) {
                // if the file is uploaded properly
                var message = "File Successfully Uploaded."
                $("#alertContainer").html('<div class="alert alert-success alert-dismissible fade show mb-0" role="alert"> <i class="fa-solid fa-cloud-arrow-up fa-beat-fade"></i> &nbsp;' +
                    message +
                    '</div>');
            }
            // if unsuccessful 
            else {
                console.error('File upload failed. Error: ' + xhr.status);
                // if the file is uploaded properly
                var message = "File Unsuccessfully Uploaded."
                $("#alertContainer").html('<div class="alert alert-danger alert-dismissible fade show mb-0" role="alert"> <i class="fa-solid fa-triangle-exclamation fa-beat-fade"></i> &nbsp;' +
                    + xhr.status + ": " + message +
                    '</div>');
            }
        };

        // send the request
        xhr.send(formData);


    }
    else {
        // if the file is already in the db thaen display an error
        var message = "This document already exists. Try another."
        $("#alertContainer").html('<div class="alert alert-warning alert-dismissible fade show mb-0" role="alert"> <i class="fa-solid fa-circle-exclamation fa-beat-fade"></i> &nbsp;' +
            message +
            '</div>');
    }
});

// Ask a question
const questionForm = document.getElementById('queryForm');

questionForm.addEventListener('submit', function (e) {
    e.preventDefault();

    var inputText = document.getElementById("textInput");
    const qstBtn = document.getElementById("questionBtn");

    // add the text into the chat box
    var questionCard = '<li class="list-group-item text-light">' + inputText.value +
        '</li>';
    $("#chatDisplay").append(questionCard);
    // set the submit button to a little loader icon, disable writing new text into the query bar, lighten the query bar, replace text
    qstBtn.innerHTML = '<i class="fa-solid fa-spinner fa-spin-pulse"></i>';
    $(inputText).attr('disabled', !$(inputText).attr('disabled'));
    $(inputText).attr('style', 'color:rgb(180, 180, 180) !important');
    var userQuestion = inputText.value;
    inputText.value = "Generating...";
    $('#queryForm').css('background-color', 'rgb(128, 138, 148)');

    // make the GET request with our inputTest
    fetch("/query?text=" + encodeURIComponent(userQuestion))
        .then(response => response.json())
        .then(data => {
            let dataTxt = data.trimStart();
            
            var responseCard = '<li class="list-group-item resp-item text-light">' + dataTxt +
                 '</li>';

            $("#chatDisplay").append(responseCard);

            // reset all the changes
            qstBtn.innerHTML = '<i class="fa-solid fa-angles-right"></i>';
            $(inputText).attr('disabled', !$(inputText).attr('disabled'));
            $(inputText).removeAttr('style', 'color:rgb(180, 180, 180) !important');
            inputText.value = "";
            $('#queryForm').css('background-color', 'rgb(101, 112, 122)');

        })
        .catch(error => {
            var responseCard = '<li class="list-group-item resp-item text-light">' + "An error occurred. Please try again later." +
                 '</li>';

            $("#chatDisplay").append(responseCard);
        });
});